	.globl _main
	
_main:
	push	ds
	push	ax		;  For later restoring
	push	cx
	push	si
	
	push	ds
	push	cs		;  For printing
	push	cs		;  For calculating DS
	call	realmain
	
realmain:
	pop	ax
	cmp	ax,#0x100	;  Are we running as a DOS binary?
	jb	notcom		;  No - Set DS = CS
	pop	ax
	add	ax,#16		;  Yes - DS = CS+0x10
	push	ax
	pop	ds
	push	ds
	mov	byte ptr finalret,#0xc3	;  Set out return to ret not retf
notcom:
	pop	ds		;  Load the correct DS

	mov	si,#XCSwas
	call	printstring
	pop	ax		;  Print our original CS
	call	phword

	mov	si,#XDSwas
	call	printstring
	pop	ax		;  Print our original DS
	call	phword

	mov	si,#XDSnow
	call	printstring
	mov	ax,ds		;  Print out current DS
	call	phword

	
	mov	si,#0x200
	call	mainloop	;  Print some data to check that
				;  the whole 0x200 bytes were loaded   

	mov	si,#0x300
	call	mainloop

	mov	si,#0x1ffe
	call	mainloop

	mov	si,#Xcontrol	;  Print a happy message
	call	printstring

	mov	cx,#0xFFFF	;  Wait for a while.
bigloop:
	loop	bigloop

	pop	si
	pop	cx
	pop	ax		;  restore regs
	pop	ds
finalret:	
	retf			;  return to BIOS

	
mainloop:
	push	si
	push	ax
	lodsw
	sub si,#2
	
	push	ax
	push	si

	mov	si,#Xwordat
	call	printstring

	pop	ax
	call	phword

	mov	si,#Xwas
	call	printstring
	
	pop	ax
	call	phword

	pop	ax
	pop	si
endloop:
	jmp	endloop
	ret

Xcontrol:	
	.byte 13,10
	.ascii "We now have control of the machine, from DiskOnChip"
	.byte 13,10,0	

XCSwas:
	.byte 13,10
	.ascii "CS at start was 0x"
	.byte 0

XDSwas:
	.byte 13,10
	.ascii "DS at start was 0x"
	.byte 0

XDSnow:
	.byte 13,10
	.ascii "DS now is 0x"
	.byte 0
	
	
Xwordat:
	.byte 13,10
	.ascii "Word at 0x"
	.byte 0

Xwas:	.ascii " was 0x"
	.byte 0
	

printstring:
	mov	ah, #0x0e
prloop:	
	lodsb
	or	al,al
	jz	endpr
	int	0x10
	jmp	prloop
endpr:	ret

phword:         push    ax
                xchg    al,ah
                call    phbyte
                mov     al,ah
                call    phbyte
                pop     ax
                ret

phbyte:         push    ax
                mov     ah,al
                shr     al,1
                shr     al,1
                shr     al,1
                shr     al,1
                call    phnibble
                mov     al,ah
                call    phnibble
                pop     ax
                ret


phnibble:       push    ax
                and     al,#0xF
                add     al,#48
                cmp     al,#57
                jna     ph1
                add     al,#7
ph1:            mov     ah,#0x0E
                int     0x10
                pop     ax
                ret

.org 0x200
	.byte 0x55, 0xaa

.org 0x300
	.byte 0xaa, 0x55

.org 0x1ffe
	.byte 0x5a, 0
